## performous 1.3.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(Performous CXX C)

set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Produce verbose makefile" FORCE)

include(GNUInstallDirs)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

if(NOT PERFORMOUS_VERSION)
    message("No project version specified. Determining latest tag..")
    include(GetGitRevisionDescription)
    git_describe(PROJECT_VERSION --tags)
    if(NOT PROJECT_VERSION)
        message("No project version found. Falling back onto default versioning strategy.")
        set(PROJECT_VERSION "1.3+")
    endif()
else()
    set(PROJECT_VERSION "${PERFORMOUS_VERSION}")
endif()
string(TIMESTAMP YEAR "%Y")

message("Building ${PROJECT_NAME} ${PROJECT_VERSION}")

# Avoid source tree pollution
get_filename_component(REAL_SOURCE_DIR "${CMAKE_SOURCE_DIR}" REALPATH)
get_filename_component(REAL_BUILD_DIR "${CMAKE_BINARY_DIR}" REALPATH)
if(REAL_SOURCE_DIR STREQUAL REAL_BUILD_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(REAL_SOURCE_DIR STREQUAL REAL_BUILD_DIR)

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT DEFINED CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=RelWithDebInfo. Use ccmake or the command-line to set a proper value.")
	set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT DEFINED CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE STREQUAL "Release")
	add_definitions("-DNDEBUG")
endif()

option(USE_BOOST_FS "Whether to use boost filsystem instead of c++17" FALSE)

if (APPLE)
	if (${CMAKE_OSX_DEPLOYMENT_TARGET})
		message (STATUS "Checking macOS deployment target... ${CMAKE_OSX_DEPLOYMENT_TARGET}")
		if (${CMAKE_OSX_DEPLOYMENT_TARGET} VERSION_GREATER_EQUAL 10.15)
			message (STATUS "Targeting macOS 10.15 or newer, enabling std::filesystem")
                else ()
			set(USE_BOOST_FS TRUE)
		endif()
	else()
		execute_process(COMMAND /usr/bin/sw_vers "-productVersion" OUTPUT_VARIABLE HOST_MACOS_VERSION)
		message (STATUS "macOS deployment target not set; checking host... ${HOST_MACOS_VERSION}")
		if (${HOST_MACOS_VERSION} VERSION_LESS 10.15)
			set(USE_BOOST_FS TRUE)
		endif()
	endif()
endif()

if(WIN32)
	if (MINGW)
		set(CPACK_MINGW_SYSTEM_PREFIX "C:/msys64/mingw64" CACHE PATH "Path to the mingw-w64 system root.")
	endif()
	set(CMAKE_CXX_FLAGS "-DWIN32_LEAN_AND_MEAN ${CMAKE_CXX_FLAGS}")
	set(CMAKE_INSTALL_DATAROOTDIR ".")
	set(CMAKE_INSTALL_LOCALEDIR "locale")
elseif(NOT APPLE)
	set(CMAKE_INSTALL_DATAROOTDIR "share/games/performous")
	set(CMAKE_INSTALL_LOCALEDIR "share/locale")
elseif(APPLE)
	set(PERFORMOUS_BUNDLE_LOCATION "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Location to put the Performous app bundle in." FORCE)
	mark_as_advanced(PERFORMOUS_BUNDLE_LOCATION)
	# make sure CMAKE_INSTALL_PREFIX ends in /
	if(NOT CMAKE_INSTALL_PREFIX MATCHES "/$")
		string(APPEND CMAKE_INSTALL_PREFIX "/")
	set (CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Location to put the Performous app bundle in.")
	endif()
	string(APPEND CMAKE_INSTALL_PREFIX "Performous.app/Contents")
	set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
	set(CMAKE_INSTALL_DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/Resources")
	set(CMAKE_INSTALL_DATADIR "${CMAKE_INSTALL_DATAROOTDIR}")
	set(CMAKE_INSTALL_LOCALEDIR "${CMAKE_INSTALL_DATAROOTDIR}/Locale")
	set(CMAKE_INSTALL_SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/Resources/etc")
	set(CMAKE_INSTALL_BINDIR "${CMAKE_INSTALL_PREFIX}/MacOS")
	set(CMAKE_INSTALL_MANDIR "${CMAKE_INSTALL_PREFIX}/Resources/man/man6")
endif()

set(CMAKE_CXX_FLAGS_RelWithDebInfo "${CMAKE_CXX_FLAGS_RelWithDebInfo} -O3")

set(SHARE_INSTALL "${CMAKE_INSTALL_DATAROOTDIR}" CACHE INTERNAL "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
mark_as_advanced(SHARE_INSTALL)

set(LOCALE_DIR "${CMAKE_INSTALL_LOCALEDIR}" CACHE INTERNAL "Locale file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
mark_as_advanced(LOCALE_DIR)

find_package(Gettext)
if(Gettext_FOUND)
	message(STATUS "Localization enabled: Building and installing .mo files")
	add_subdirectory(lang)
else()
	message(STATUS "Localization disabled: Gettext tools (msgfmt) missing")
endif()

add_subdirectory(data)

add_subdirectory(game)

target_compile_options(performous PRIVATE $<$<CXX_COMPILER_ID:MSVC>:/W4> $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wall> $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wextra> $<$<CXX_COMPILER_ID:gcc>:-fcx-limited-range> $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wconversion>)


add_subdirectory(docs)

if(APPLE)
	add_subdirectory(osx-utils)
endif()

if(NOT APPLE)
  # uninstall target
  if(NOT TARGET uninstall)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake/uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake/uninstall.cmake"
      IMMEDIATE @ONLY)

    add_custom_target(uninstall
      COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake/uninstall.cmake)
  endif()
endif()

if(WIN32)
	set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION ".")
endif()

#CPACK variables
include(InstallRequiredSystemLibraries)

# Project definition
set(CPACK_PACKAGE_VENDOR "Performous")
set(CPACK_PACKAGE_DESCRIPTION "Karaoke, band games and dancing in the same package. Performous lets you perform great songs, improve your musical skills and simply have fun! No special hardware required, you may play guitar on your PC keyboard, sing on your laptop microphone and so on. If you do have SingStar microphones, Guitar Hero or Rock Band instruments, or dance pads, just plug them into your USB ports and start rocking!")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An open-source music and rhythm game.")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md")
if(WIN32)
	set(CPACK_PACKAGE_EXECUTABLES "Performous" "${CMAKE_CURRENT_SOURCE_DIR}/win32\\\\performous.ico")
	set(CPACK_PACKAGE_INSTALL_DIRECTORY "Performous\\\\Performous")
else()
	set(CPACK_PACKAGE_EXECUTABLES "performous")
endif()
set(CPACK_PACKAGE_CONTACT "Arjan Speiard | Asgard Sings! <info@asgardsings.nl>")

if(NOT CPACK_PACKAGE_VERSION)
	set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")
endif()
set(CPACK_INSTALL_CMAKE_PROJECTS "${CPACK_INSTALL_CMAKE_PROJECTS};${CMAKE_BINARY_DIR};${PROJECT_NAME};ALL;/")

set(BUILD_TESTS AUTO CACHE STRING "Build tests [OFF|AUTO*|ON]")
set_property(CACHE BUILD_TESTS PROPERTY STRINGS AUTO ON OFF)


if(BUILD_TESTS STREQUAL "AUTO" OR BUILD_TESTS STREQUAL "ON")
	enable_testing()
	add_subdirectory(testing)
endif()

# Debian specific settings
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_PACKAGE_SECTION "Games")

# RPM specific settings
set(CPACK_RPM_PACKAGE_GROUP "Amusements/Games")

set(CPACK_RPM_PACKAGE_REQUIRES "cairo-devel, librsvg2-devel, glibmm24-devel, libxml++-devel, boost-devel, SDL2-devel, libepoxy-devel, ffmpeg-devel, portaudio-devel, opencv-devel, portmidi-devel, libjpeg-turbo-devel, pango-devel, libpng-devel, glm-devel, openblas-devel, fftw-devel, cpprest-devel")
set(CPACK_RPM_PACKAGE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md")

set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "${LC_MESSAGES_DIRS}")
set(CPACK_RPM_PACKAGE_DESCRIPTION "${CPACK_PACKAGE_DESCRIPTION}")
set(CPACK_RPM_PACKAGE_URL "https://github.com/performous/performous")

# NSIS specific settings
set(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}/win32\\\\performous.ico")
set(CPACK_NSIS_MUI_UNIICON "${CMAKE_CURRENT_SOURCE_DIR}/win32\\\\performous.ico")
set(CPACK_NSIS_MUI_WELCOMEFINISHPAGE_BITMAP "${CMAKE_CURRENT_SOURCE_DIR}/win32/nsis\\\\welcomefinishpage.bmp")
set(CPACK_NSIS_COMPRESSOR "/SOLID lzma")
set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL ON)
set(CPACK_NSIS_MODIFY_PATH OFF)
set(CPACK_NSIS_DISPLAY_NAME "${PROJECT_NAME}")
set(CPACK_NSIS_PACKAGE_NAME "${CPACK_NSIS_DISPLAY_NAME}")
set(CPACK_NSIS_INSTALLED_ICON_NAME "${PROJECT_NAME}.exe")
set(CPACK_NSIS_HELP_LINK "https://github.com/performous/performous")
set(CPACK_NSIS_URL_INFO_ABOUT "https://performous.org")
set(CPACK_NSIS_CONTACT "${CPACK_PACKAGE_CONTACT}")
set(CPACK_NSIS_CREATE_ICONS_EXTRA "CreateShortCut '$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\${PROJECT_NAME}.lnk' '$INSTDIR\\\\${PROJECT_NAME}.exe'"
								  "CreateShortcut '$SMPROGRAMS\\\\Performous\\\\Uninstall.lnk' '$INSTDIR\\\\Uninstall.exe''")
set(CPACK_NSIS_DELETE_ICONS_EXTRA "Delete '$SMPROGRAMS\\\\$START_MENU\\\\${PROJECT_NAME}.lnk'"
								  "Delete '$SMPROGRAMS\\\\$START_MENU\\\\Uninstall.lnk'")
set(CPACK_NSIS_EXECUTABLES_DIRECTORY ".")
set(CPACK_NSIS_MUI_FINISHPAGE_RUN "${PROJECT_NAME}.exe")
set(CPACK_NSIS_MENU_LINKS "https://discord.gg/NS3m3ad" "Performous Discord")
set(CPACK_NSIS_WELCOME_TITLE "Welcome to the Performous installer.")
set(CPACK_NSIS_FINISH_TITLE "Congratulations Performous is now installed.")
set(CPACK_NSIS_MUI_HEADERIMAGE "${CMAKE_CURRENT_SOURCE_DIR}/win32/nsis\\\\headerimage.bmp")
set(CPACK_NSIS_MANIFEST_DPI_AWARE ON)
set(CPACK_NSIS_BRANDING_TEXT "Performous installer ${PROJECT_VERSION} 2009-${YEAR}")

# macOS specific settings
set(CPACK_BUNDLE_NAME "Performous")
set(CPACK_BUNDLE_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/osx-utils/resources/Info.plist")
set(CPACK_BUNDLE_ICON "${CMAKE_CURRENT_SOURCE_DIR}/osx-utils/resources/Performous.icns")

if (APPLE)
	set(CPACK_SOURCE_GENERATOR "")
	set(CPACK_GENERATOR "Bundle")
	set(CMAKE_XCODE_ATTRIBUTE_MARKETING_VERSION "${PROJECT_VERSION}")
	set(CMAKE_XCODE_ATTRIBUTE_PRODUCT_BUNDLE_IDENTIFIER "org.performous.Performous")
	set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED "NO")
	set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "")
elseif(WIN32)
	set(CPACK_GENERATOR "NSIS64;TGZ;ZIP")
else()
	set(CPACK_GENERATOR "TGZ;ZIP;DEB;RPM;NSIS64")
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release")
	set (CPACK_STRIP_FILES TRUE)
endif()

include(CPack)

=== data/CMakeLists.txt ===
set(APPLICATION_FILE "performous.desktop")
set(PIXMAP_FILE      "themes/default/icon.svg")

# Install launcher and fonts on system level
if(UNIX AND NOT APPLE)
	install(FILES "${APPLICATION_FILE}" DESTINATION "/usr/share/applications/")
	install(FILES "${PIXMAP_FILE}" DESTINATION "/usr/share/pixmaps/" RENAME "performous.svg")
endif()

install(DIRECTORY backgrounds config fonts shaders sounds themes xsl DESTINATION ${SHARE_INSTALL})

=== game/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

file(GLOB SOURCE_FILES
	"*.cc"
	"graphic/*.cc"
	"songorder/*.cc"
	"utils/*.cc"
)
file(GLOB HEADER_FILES
	"*.hh"
	"graphic/*.hh"
	"songorder/*.hh"
	"utils/*.hh"
	"libda/*.hpp"
)

# Fs is compiled/linked separately to ease switch boost/c++17
list(REMOVE_ITEM SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/fs.cc)
list(REMOVE_ITEM HEADER_FILES ${CMAKE_CURRENT_SOURCE_DIR}/fs.hh)

if(WIN32)
	# We want to support all these version numbers:
	# 1.0 1.0.1 1.0+ 1.0.1+ 1.0-2-g123abcd 1.0.1-5-g123abcd
	# We use the 2-3 digits of the version as MAJOR.MINOR.PATCH
	# and the git patch number as TWEAK
	set(SUBSYSTEM_WIN32 WIN32)
	if (DEFINED CMAKE_SOURCE_DIR)
		if(DEFINED ENV{ORIGINAL_TEMP})
			set (TMP_LOCATION $ENV{ORIGINAL_TEMP})
		elseif(DEFINED ENV{TEMP})
			set (TMP_LOCATION $ENV{TEMP})
		else()
			message(WARNING "Temp folder not found. CPack won't be able to create a proper installer.")
		endif()
		file(WRITE "${TMP_LOCATION}/source.txt" "${CMAKE_SOURCE_DIR}")
		file(WRITE "${TMP_LOCATION}/mingwroot.txt" "${CPACK_MINGW_SYSTEM_PREFIX}")
	endif()
	string(REGEX REPLACE "\\." ";"  VERSIONING ${PROJECT_VERSION})
	list(GET VERSIONING -1 LAST_ENTRY)
	list(REMOVE_AT VERSIONING -1)
	string(REGEX REPLACE "^([0-9]+)(.*)$" "\\1;\\2"  LAST_ENTRIES ${LAST_ENTRY})
	list(GET LAST_ENTRIES 0 LAST_ENTRY_NUM)
	list(GET LAST_ENTRIES 1 LAST_ENTRY_ADD)
	list(APPEND VERSIONING ${LAST_ENTRY_NUM})

	list(GET VERSIONING 0 VERSION_MAJOR)
	list(LENGTH VERSIONING VERSION_LENGTH)
	if(VERSION_LENGTH GREATER 1)
		list(GET VERSIONING 1 VERSION_MINOR)
	endif()
	if(VERSION_LENGTH GREATER 2)
		list(GET VERSIONING 2 VERSION_PATCH)
	endif()

	string(REGEX REPLACE "^-([0-9]+)-.*$" "\\1" VERSION_TWEAK "${LAST_ENTRY_ADD}")

	set(VERSIONS "MAJOR" "MINOR" "PATCH" "TWEAK")
	foreach(v ${VERSIONS})
		if(NOT VERSION_${v} MATCHES "^[0-9]+$")
			set(VERSION_${v} "0")
		endif()
	endforeach()
	message(STATUS "Setting .exe version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_TWEAK}")

	set(RESOURCE_FILES "${CMAKE_BINARY_DIR}/performous.rc")
	configure_file("../win32/performous.cmake.rc" "${RESOURCE_FILES}")

	if(MINGW)
		# According to MinGW tools, we need to compile the rc file, and then link it into projects:
		# windres foo.rc foores.o
		# gcc -o foo.exe foo.o foores.o
		if(NOT CMAKE_RC_COMPILER)
			find_program(CMAKE_RC_COMPILER "${CPACK_MINGW_SYSTEM_PREFIX}/bin/windres")
		endif()
		if(NOT CMAKE_RC_COMPILER)
			message(STATUS "Cannot find windres. Will not create a versioned exe.")
			set(RESOURCE_FILES)
		else()
			set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
		endif()
	endif()
else()
	set(RESOURCE_FILES) #nothing
endif()

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES} ${RESOURCE_FILES})

# Build main executable
add_executable(performous ${SUBSYSTEM_WIN32} ${SOURCES} ${SDL2_SOURCES})
# Libraries

find_package(Boost 1.55 REQUIRED COMPONENTS program_options iostreams system locale)
target_include_directories(performous SYSTEM PRIVATE ${Boost_INCLUDE_DIRS})
target_link_libraries(performous PRIVATE ${Boost_LIBRARIES})

add_library(fs STATIC fs.cc)
target_include_directories(fs PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
if (USE_BOOST_FS)
	find_package(Boost 1.55 REQUIRED COMPONENTS filesystem)

	message (STATUS "Using boost::filesystem")
	target_link_libraries(fs PUBLIC Boost::filesystem)
	target_compile_definitions(fs PUBLIC -DUSE_BOOST_FS)
else()
	find_package(Filesystem REQUIRED)
	message (STATUS "Using std::filesystem")
	target_link_libraries(fs PRIVATE std::filesystem)
endif()

find_package(ICU 60 REQUIRED uc data i18n io)
target_include_directories(performous SYSTEM PRIVATE ${ICU_INCLUDE_DIRS})
target_link_libraries(performous PRIVATE ${ICU_LIBRARIES})

# LibEpoxy < 1.2 crashes with binary drivers (nvidia & fglrx) when creating shaders
# (see https://github.com/anholt/libepoxy/issues/23 for the exact problem)
find_package(LibEpoxy 1.2 REQUIRED)
target_include_directories(performous SYSTEM PRIVATE ${LibEpoxy_INCLUDE_DIRS})
target_link_libraries(performous PRIVATE ${LibEpoxy_LIBRARIES})

find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET glib-2.0 gio-2.0 gobject-2.0)

set(SELF_BUILT_GIT_BASE "https://github.com/performous" CACHE STRING "base path of the git trees used for self built dependencies")
set(SELF_BUILT_AUBIO "NEVER" CACHE STRING "rule to allow self build of Aubio dependency library [NEVER*|AUTO|ALWAYS]")
set(SELF_BUILT_JSON "NEVER" CACHE STRING "rule to allow self build of Json dependency library [NEVER*|AUTO|ALWAYS]")

set(Aubio_REQUIRED_VERSION "0.4.9")

# Find all the libs that don't require extra parameters

if (MINGW)
	target_link_libraries(performous PRIVATE mingw32)
endif()

foreach(lib ${OUR_LIBS} SDL2 PangoCairo LibRSVG LibXML++ AVFormat SWResample SWScale ZLIB JPEG PNG PortAudio Fontconfig GLM Json Ced Aubio)
	find_package(${lib} ${${lib}_REQUIRED_VERSION} REQUIRED)
	message(STATUS "${lib} includes: ${${lib}_INCLUDE_DIRS}")
	target_include_directories(performous SYSTEM PRIVATE ${${lib}_INCLUDE_DIRS})
	target_link_libraries(performous PRIVATE ${${lib}_LIBRARIES})
	add_definitions(${${lib}_DEFINITIONS})
endforeach(lib)

find_package(fmt REQUIRED CONFIG)
# CppRESTSDK and their godforsaken U macro.
if(fmt_VERSION VERSION_GREATER_EQUAL 9.0.0)
	target_compile_definitions(performous PRIVATE -D_TURN_OFF_PLATFORM_STRING)
endif()

target_link_libraries(performous PRIVATE fmt::fmt)

target_include_directories(fs PRIVATE ${SDL2_INCLUDE_DIRS})
target_link_libraries(fs PRIVATE ${SDL2_LIBRARIES})

# Activating MIDI hardware (e-drums with USB/MIDI connection)
set(ENABLE_MIDI AUTO CACHE STRING "Use midi hardware (e-drums with USB/MIDI connection)")
set_property(CACHE ENABLE_MIDI PROPERTY STRINGS AUTO ON OFF)
if("AUTO" STREQUAL "${ENABLE_MIDI}")
	# Midi support not requested explicitly, best effort try to find it
	find_package(PortMidi QUIET)
	if(PortMidi_FOUND)
		message(STATUS "MIDI I/O support: Enabled (automatically found)")
	else()
		message(STATUS "MIDI I/O support: Disabled (libportmidi not found)")
	endif()
elseif(ENABLE_MIDI)
	# Midi support explicitly requested, make it mandatory
	find_package(PortMidi REQUIRED)
	message(STATUS "MIDI I/O support: Enabled (explicitly enabled)")
else()
	# Midi support explicitly disabled
	message(STATUS "MIDI I/O support: Disabled (explicitly disabled)")
endif()

if(PortMidi_FOUND)
	include_directories(${PortMidi_INCLUDE_DIRS})
	list(APPEND LIBS ${PortMidi_LIBRARIES})
	add_definitions("-DUSE_PORTMIDI")
endif()

# Activating webcam
set(ENABLE_WEBCAM AUTO CACHE STRING "Use webcam")
set_property(CACHE ENABLE_WEBCAM PROPERTY STRINGS AUTO ON OFF)
if("AUTO" STREQUAL "${ENABLE_WEBCAM}")
	# webcam support not requested explicitly, best effort try to find it
	find_package(OpenCV COMPONENTS core videoio)
	if(OPENCV_VIDEOIO_FOUND)
		message(STATUS "Webcam support: Enabled (automatically found)")
	else()
		message(STATUS "Webcam support: Disabled (OpenCV (libcv/libhighgui) not found)")
	endif()
elseif(ENABLE_WEBCAM)
	# webcam support explicitly requested, make it mandatory
	find_package(OpenCV REQUIRED core videoio)
	message(STATUS "Webcam support: Enabled (explicitly enabled)")
else()
	# webcam support explicitly disabled
	message(STATUS "Webcam support: Disabled (explicitly disabled)")
endif()

if(OPENCV_VIDEOIO_FOUND)
	target_include_directories(performous SYSTEM PRIVATE ${OpenCV_INCLUDE_DIRS})
	target_link_libraries(performous PRIVATE ${OpenCV_LIBS})
	add_definitions("-DUSE_OPENCV")
endif()

# Activating webserver
set(ENABLE_WEBSERVER AUTO CACHE STRING "Use webserver")
set_property(CACHE ENABLE_WEBSERVER PROPERTY STRINGS AUTO ON OFF)
if("AUTO" STREQUAL "${ENABLE_WEBSERVER}")
	# webserver not requested explicitly, best effort try to find it
	find_package(cpprestsdk QUIET)
	if (NOT cpprestsdk_FOUND)
		find_package(CppRest QUIET)
	endif()
	if(cpprestsdk_FOUND OR CppRest_FOUND)
		message(STATUS "Webserver support: Enabled (automatically found)")
	else()
		message(STATUS "Webserver support: Disabled (cpprestsdk not found)")
		SET (ENABLE_WEBSERVER OFF FORCE)
	endif()
elseif(ENABLE_WEBSERVER)
	# webserver explicitly requested, make it mandatory
	find_package(cpprestsdk)
	if (NOT cpprestsdk_FOUND)
		find_package(CppRest QUIET REQUIRED)
	endif()
	if(cpprestsdk_FOUND OR CppRest_FOUND)
		message(STATUS "Webserver support: Enabled (explicitly enabled)")
	else()
	# webserver explicitly disabled
		message(STATUS "Webserver support: Disabled (explicitly disabled)")
	endif()
endif()

# if cpprest is found, add it to the dependencies
if(cpprestsdk_FOUND OR CppRest_FOUND)
	# add other required dependencies then
	# FIXME: move this to the CppRest package includes if possible
	find_package(Boost 1.55 REQUIRED COMPONENTS chrono thread)
	find_package(OpenSSL REQUIRED)
	if(cpprestsdk_FOUND)
		target_link_libraries(performous PRIVATE cpprestsdk::cpprest)
	else()
		target_include_directories(performous SYSTEM PRIVATE ${CppRest_INCLUDE_DIRS})
		target_link_libraries(performous PRIVATE ${CppRest_LIBRARIES})
	endif()
	target_link_libraries(performous PRIVATE Boost::boost Boost::chrono OpenSSL::SSL OpenSSL::Crypto)
	add_definitions("-DUSE_WEBSERVER")
endif()

if(WIN32)
	add_definitions("-DEPOXY_SHARED")
	set(BIN_INSTALL .)  # Straight to Program Files/Performous with no bin subfolder.
	if(ENABLE_WEBSERVER)
	  target_link_libraries(performous PRIVATE wsock32 ws2_32)
	endif()
elseif(APPLE)
	set(BIN_INSTALL MacOS)
else()
	set(BIN_INSTALL bin)
endif()

if(APPLE)
	list(APPEND LIBS "-framework Accelerate")
endif()
list(APPEND LIBS ${FFTW3_LIBRARIES})
list(APPEND LIBS ${BLAS_LIBRARIES})

find_package(Threads)
target_link_libraries(performous PRIVATE fs ced aubio ${LIBS} PkgConfig::deps Threads::Threads)

if (NOT APPLE)
	install(TARGETS performous DESTINATION ${BIN_INSTALL})
endif()

if (APPLE AND ${CMAKE_GENERATOR} STREQUAL "Xcode")
	set(PATH "$ENV{PATH}")
	EXECUTE_PROCESS(
		COMMAND /usr/bin/defaults read -g AppleLanguages
		OUTPUT_VARIABLE PERFORMOUS_LANG
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
	string(REGEX REPLACE
	"[ \"\(\)\t\r\n]"
	""
	PERFORMOUS_LANG
	${PERFORMOUS_LANG}
	)
	string(REGEX REPLACE
	"-([A-Z][A-Z]),"
	"_\\1; "
	PERFORMOUS_LANG
	${PERFORMOUS_LANG}
	)
	set(PERFORMOUS_LANG ${PERFORMOUS_LANG})
	list(GET PERFORMOUS_LANG 0 PERFORMOUS_LANG)
	set_target_properties(performous PROPERTIES
	XCODE_SCHEME_EXECUTABLE "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL}/performous"
	XCODE_SCHEME_ARGUMENTS "--log debug"
	XCODE_SCHEME_ENVIRONMENT "FONTCONFIG_PATH=\"${CMAKE_INSTALL_SYSCONFDIR}/fonts\";
	GDK_PIXBUF_MODULE_FILE=\"\";
	LANG=\"${PERFORMOUS_LANG}.UTF-8\""
	)
endif()

set_target_properties(performous PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)  # Store library paths in executable
set_target_properties(performous PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})  # Produce executable in build/, not build/game/

# Capitalized Performous.exe on Windows (this is considered more beautiful).
if(WIN32)
	set_target_properties(performous PROPERTIES OUTPUT_NAME "Performous")
endif()

if(WIN32 AND MSVC)
#	target_compile_options(performous PUBLIC /WX)
else()
	target_compile_options(performous PUBLIC -Werror)
endif()

# Generate config.hh
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.hh" "${CMAKE_CURRENT_BINARY_DIR}/config.hh" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

if(WIN32 AND MSVC)
	install(CODE [[
		file(GET_RUNTIME_DEPENDENCIES
			RESOLVED_DEPENDENCIES_VAR deps_resolved
			UNRESOLVED_DEPENDENCIES_VAR deps_unresolved
			EXECUTABLES $<TARGET_FILE:performous>
			PRE_EXCLUDE_REGEXES "api-ms-*" "ext-ms-*"
			POST_EXCLUDE_REGEXES ".*system32/.*\\.dll"
			)
		message(STATUS "Resolving runtime dependencies for $<TARGET_FILE:performous>")
		foreach(dep ${deps_resolved})
			file(INSTALL ${dep} DESTINATION ${CMAKE_INSTALL_PREFIX})
		endforeach()
		foreach(dep ${deps_unresolved})
			message(WARNING "Runtime dependency ${dep} could not be resolved.")
		endforeach()
		]])
elseif(MINGW)

=== osx-utils/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

set(PERFORMOUS_SEMVER "" CACHE STRING "Version in semver format")
set(PERFORMOUS_LOG_LEVEL "" CACHE STRING "Log level to set in launcher script")
set(PERFORMOUS_SHORT_VERSION "" CACHE STRING "Short version string")

set_target_properties(performous PROPERTIES
	OUTPUT_NAME "Performous"
	MACOSX_BUNDLE TRUE
	MACOSX_BUNDLE_BUNDLE_VERSION "${PERFORMOUS_SEMVER}"
	MACOSX_BUNDLE_SHORT_VERSION_STRING "${PERFORMOUS_SHORT_VERSION}"
	MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_LIST_DIR}/resources/Info.plist.in"
	MACOSX_BUNDLE_COPYRIGHT "Performous ${PERFORMOUS_VERSION}, distributed by Performous team and contributors under the GPL 2.0")

set(PERFORMOUS_PATH "${CMAKE_PREFIX_PATH}")
list(GET
	PERFORMOUS_PATH
	0
	PERFORMOUS_SYSTEM_PREFIX
)

file(READ
	"${PERFORMOUS_SYSTEM_PREFIX}/etc/fonts/fonts.conf"
	PERFORMOUS_FONTS_CONF
)

string(REPLACE "<dir>@PERFORMOUS_SYSTEM_PREFIX@"
	"<dir prefix='relative'>../../../Resources" PERFORMOUS_FONTS_CONF
	"${PERFORMOUS_FONTS_CONF}")

string(REPLACE "<dir>@PERFORMOUS_SYSTEM_PREFIX@/var/cache"
	"~/.cache" PERFORMOUS_FONTS_CONF
	"${PERFORMOUS_FONTS_CONF}")

string(REPLACE "<!-- Font directory list -->"
	[=[<!-- Font directory list -->
	<dir prefix='relative'>../../pixmaps</dir>]=] PERFORMOUS_FONTS_CONF
	"${PERFORMOUS_FONTS_CONF}")

string(REPLACE "@PERFORMOUS_SYSTEM_PREFIX@/share"
	"../../../Resources" PERFORMOUS_FONTS_CONF
	"${PERFORMOUS_FONTS_CONF}")

file(WRITE
	"${CMAKE_INSTALL_SYSCONFDIR}/fonts/fonts.conf"
	"${PERFORMOUS_FONTS_CONF}")

install(DIRECTORY
	"${PERFORMOUS_SYSTEM_PREFIX}/etc/fonts/conf.d"
	DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/fonts/"
)

configure_file(
	"resources/performous-launcher.in"
	"performous-launcher"
	@ONLY
)
	
install(PROGRAMS
	"${CMAKE_CURRENT_BINARY_DIR}/performous-launcher"
	TYPE BIN
)

install(TARGETS performous BUNDLE
	BUNDLE DESTINATION "${PERFORMOUS_BUNDLE_LOCATION}"
)

install(FILES "resources/performous.icns"
	TYPE DATA
)

=== testing/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
include(GoogleTest)

set(SOURCE_FILES
	"analyzertest.cc"
	"colortest.cc"
	"configitemtest.cc"
	"cycletest.cc"
	"fixednotegraphscalertest.cc"
	"notegraphscalerfactorytest.cc"
	"printer.cc"
	"ringbuffertest.cc"
	"utiltest.cc"
)
set(GAME_SOURCES
	"../game/analyzer.cc"
	"../game/color.cc"
	"../game/configitem.cc"
	"../game/dynamicnotegraphscaler.cc"
	"../game/fixednotegraphscaler.cc"
	"../game/musicalscale.cc"
	"../game/notes.cc"
	"../game/notegraphscalerfactory.cc"
	"../game/tone.cc"
	"../game/util.cc"
)

set(GTEST_REQUIRED "")

if(BUILD_TESTS STREQUAL "ON")
	set(GTEST_REQUIRED "REQUIRED")
endif()

find_package(GTest ${GTEST_REQUIRED})

if(GTest_FOUND)
	message(STATUS "Testing enabled: Building test host")

	set(SOURCES ${SOURCE_FILES} ${HEADER_FILES} ${GAME_SOURCES})

	add_executable(performous_test ${SOURCES})

	find_package(Boost 1.55 REQUIRED COMPONENTS program_options iostreams system locale)
	target_link_libraries(performous_test PRIVATE ${Boost_LIBRARIES})

	find_package(fmt REQUIRED CONFIG)
	target_link_libraries(performous_test PRIVATE fmt::fmt)

	if(${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.20)
		target_link_libraries(performous_test PRIVATE GTest::gtest GTest::gtest_main GTest::gmock)
	else()
		if(NOT TARGET GTest::gmock)
			find_package(GMock MODULE REQUIRED)
			add_library(GTest::gmock ALIAS GMock)
		endif()
		target_link_libraries(performous_test PRIVATE GTest::GTest GTest::Main GTest::gmock)
	endif()

	target_include_directories(performous_test PRIVATE ".." "../game")

	if(WIN32 AND MSVC)
#		target_compile_options(performous_test PUBLIC /WX)
	else()
		target_compile_options(performous_test PUBLIC -Werror)
	endif()

	gtest_discover_tests(performous_test)

else()
	message(STATUS "Testing disabled: Package gtest missing")
endif()

=== debian/changelog ===
performous (1.3.0+ds-2) unstable; urgency=medium

  * Team Upload
  * Fix FTBFS with ffmpeg 7.0 (Closes: #1072444, #1081353, #1081354)
  * Set Rules-Requires-Root: no

 -- Alexandre Detiste <tchet@debian.org>  Fri, 29 Nov 2024 17:47:59 +0100

performous (1.3.0+ds-1) unstable; urgency=medium

  * New upstream version 1.3.0.

 -- Markus Koschany <apo@debian.org>  Fri, 15 Sep 2023 13:31:12 +0200

performous (1.3.0~rc1+ds-2) unstable; urgency=medium

  * Remove libopenblas-dev from Build-Depends. The library is not available on
    several architectures.
  * Add no-Werror.patch. Don't fail if there are compiler warnings.

 -- Markus Koschany <apo@debian.org>  Thu, 07 Sep 2023 17:09:44 +0200

performous (1.3.0~rc1+ds-1) unstable; urgency=medium

  * New upstream version 1.3.0~rc1+ds. (Closes: #1023125)
    - Repack the tarball and include the ced library.
    - New release builds fine with latest ffmpeg version in Debian.
      (Closes: #1041505)
  * Update debian/watch and track latest releases on github.com.
  * d/control: Update the list of build-dependencies.
  * Drop all existing patches because they are obsolete.
  * Add ced.patch to fix a FTBFS.
  * Stop replacing Droid Sans Mono with Noto Mono.
  * Drop performous-tools binary package because this needs to be packaged
    separately now.
  * Update debian/copyright and README.source.

 -- Markus Koschany <apo@debian.org>  Wed, 06 Sep 2023 20:21:15 +0200

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)

OUR_CPPFLAGS:=
OUR_CXXFLAGS:=
OUR_LDFLAGS:=	-Wl,--as-needed

# needed so top-level exceptions are displayed as fatal errors for users
OUR_CPPFLAGS+=	-DNDEBUG

ifneq (,$(filter ${DEB_HOST_ARCH},armel m68k mips mipsel powerpc powerpcspe sh4))
OUR_LDFLAGS+=	-Wl,--start-group -latomic
endif

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND := ${OUR_CPPFLAGS}
export DEB_CXXFLAGS_MAINT_APPEND := ${OUR_CXXFLAGS}
export DEB_LDFLAGS_MAINT_APPEND := ${OUR_LDFLAGS}

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_INSTALL_PREFIX=/usr

override_dh_install:
	dh_install
	mkdir -p debian/performous/usr/games
	mv debian/performous/usr/bin/performous debian/performous/usr/games/
	rmdir --ignore-fail-on-non-empty debian/performous/usr/bin
	mkdir -p debian/performous/usr/share/icons/hicolor/scalable/apps
	mv debian/performous/usr/share/pixmaps/performous.svg \
		debian/performous/usr/share/icons/hicolor/scalable/apps/
	rmdir --ignore-fail-on-non-empty debian/performous/usr/share/pixmaps
	mkdir -p debian/performous/usr/share/man/man6
	mv debian/performous/usr/share/man/performous.6.gz \
		debian/performous/usr/share/man/man6/performous.6.gz

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[\.\-]?((rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(dfsg|debian|ds|repack|repacked)// \
  https://github.com/performous/performous/tags .*/@ANY_VERSION@@ARCHIVE_EXT@

## performous 1.3.1%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
     git_describe(PROJECT_VERSION --tags)
     if(NOT PROJECT_VERSION)
         message("No project version found. Falling back onto default versioning strategy.")
-        set(PROJECT_VERSION "1.3+")
+        set(PROJECT_VERSION "1.3.1")
     endif()
 else()
     set(PROJECT_VERSION "${PERFORMOUS_VERSION}")
@@ -82,12 +82,12 @@
 	endif()
 	string(APPEND CMAKE_INSTALL_PREFIX "Performous.app/Contents")
 	set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
-	set(CMAKE_INSTALL_DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/Resources")
+	set(CMAKE_INSTALL_DATAROOTDIR "Resources")
 	set(CMAKE_INSTALL_DATADIR "${CMAKE_INSTALL_DATAROOTDIR}")
-	set(CMAKE_INSTALL_LOCALEDIR "${CMAKE_INSTALL_DATAROOTDIR}/Locale")
-	set(CMAKE_INSTALL_SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/Resources/etc")
-	set(CMAKE_INSTALL_BINDIR "${CMAKE_INSTALL_PREFIX}/MacOS")
-	set(CMAKE_INSTALL_MANDIR "${CMAKE_INSTALL_PREFIX}/Resources/man/man6")
+	set(CMAKE_INSTALL_LOCALEDIR "${CMAKE_INSTALL_DATADIR}/Locale")
+	set(CMAKE_INSTALL_SYSCONFDIR "${CMAKE_INSTALL_DATADIR}/etc")
+	set(CMAKE_INSTALL_BINDIR "MacOS")
+	set(CMAKE_INSTALL_MANDIR "${CMAKE_INSTALL_DATADIR}/man/man6")
 endif()
 
 set(CMAKE_CXX_FLAGS_RelWithDebInfo "${CMAKE_CXX_FLAGS_RelWithDebInfo} -O3")

=== docs/CMakeLists.txt ===
if(UNIX)
	add_subdirectory(man)
endif(UNIX)

## performous 1.3.1+ds

=== CMakeLists.txt ===
# Copyright 2016 Google Inc.  All Rights Reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

# Old enough to support Ubuntu Precise.
cmake_minimum_required(VERSION 2.8.7)

if (WIN32)
  if (NOT EXISTS "compact_enc_det/compact_enc_det.h")
    message(FATAL_ERROR "\nCould not find source code.  Make sure you are running this script from the root of the distribution tree.")
  endif()

  if (NOT EXISTS "gtest")
    message(STATUS "Google Test not present.  Fetching from the web...")
    file(DOWNLOAD "https://github.com/google/googletest/archive/master.zip" ${CMAKE_SOURCE_DIR}/master.zip)
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar x master.zip)
    file(REMOVE master.zip)
    file(RENAME googletest-master gtest)
  endif()

  # Configure gtest.
  execute_process(COMMAND ${CMAKE_COMMAND} .
                          WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/gtest)
endif()

project(CED CXX)
set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 1 CACHE INTERNAL "No dev warnings")

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wno-narrowing")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wno-c++11-narrowing")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  if (NOT BUILD_SHARED_LIBS)
    foreach(flag_var
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)
  endif()
endif()

set(EXTRA_TARGET_LINK_LIBRARIES)

if(WIN32)
  add_definitions(-DUNICODE -D_UNICODE -DSTRICT -DNOMINMAX)
  set(THREADING threadwin)
else()
  set(THREADING thread)
  list(APPEND EXTRA_TARGET_LINK_LIBRARIES -pthread)
endif()

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

set(CED_LIBRARY_SOURCES
    compact_enc_det/compact_enc_det.cc
    compact_enc_det/compact_enc_det_hint_code.cc
    util/encodings/encodings.cc
    util/languages/languages.cc
    )

add_library(ced ${CED_LIBRARY_SOURCES})

target_include_directories(ced PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

# Uncomment to put CED into WHATWG-compliant mode.
#add_definitions(-DHTML5_MODE)

set(GTEST_INCLUDE_DIR "gtest/googletest/include")
set(GTEST_LIB_DIR "${CMAKE_SOURCE_DIR}/gtest/lib")

set(CED_UNITTEST_SOURCES
    compact_enc_det/compact_enc_det_unittest.cc
    compact_enc_det/compact_enc_det_fuzz_test.cc
    compact_enc_det/detail_head_string.inc
    util/encodings/encodings_unittest.cc
    )

add_executable(ced_unittest ${CED_UNITTEST_SOURCES})
include_directories(${CMAKE_SOURCE_DIR}/${GTEST_INCLUDE_DIR})
if (WIN32)
  set(GTEST_LIB_DIR_DBG "${GTEST_LIB_DIR}/Debug")
  set(GTEST_LIB_DIR_REL "${GTEST_LIB_DIR}/Release")
  target_link_libraries(ced_unittest
                        ced
                        debug ${GTEST_LIB_DIR_DBG}/gtest.lib optimized ${GTEST_LIB_DIR_REL}/gtest.lib
                        debug ${GTEST_LIB_DIR_DBG}/gtest_main.lib optimized ${GTEST_LIB_DIR_REL}/gtest_main.lib
                        ${EXTRA_TARGET_LINK_LIBRARIES})
  message("\nConfiguration completed.  Open the created projects with Visual Studio to build the packages.\n")
else()
  target_link_libraries(ced_unittest
                        ced
                        ${GTEST_LIB_DIR}/libgtest.a
                        ${GTEST_LIB_DIR}/libgtest_main.a
                        ${EXTRA_TARGET_LINK_LIBRARIES}
                        )
endif()

=== data/CMakeLists.txt ===
set(APPLICATION_FILE "performous.desktop")
set(PIXMAP_FILE      "themes/default/icon.svg")

# Install launcher and fonts on system level
if(UNIX AND NOT APPLE)
	install(FILES "${APPLICATION_FILE}" DESTINATION "${CMAKE_INSTALL_DATADIR}/applications/")
	install(FILES "${PIXMAP_FILE}" DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/" RENAME "performous.svg")
endif()

install(DIRECTORY backgrounds config fonts shaders sounds themes xsl DESTINATION ${SHARE_INSTALL})

=== game/CMakeLists.txt ===
--- 
+++ 
@@ -121,8 +121,10 @@
 pkg_check_modules(deps REQUIRED IMPORTED_TARGET glib-2.0 gio-2.0 gobject-2.0)
 
 set(SELF_BUILT_GIT_BASE "https://github.com/performous" CACHE STRING "base path of the git trees used for self built dependencies")
-set(SELF_BUILT_AUBIO "NEVER" CACHE STRING "rule to allow self build of Aubio dependency library [NEVER*|AUTO|ALWAYS]")
-set(SELF_BUILT_JSON "NEVER" CACHE STRING "rule to allow self build of Json dependency library [NEVER*|AUTO|ALWAYS]")
+set(SELF_BUILT_AUBIO "AUTO" CACHE STRING "rule to allow self build of Aubio dependency library [NEVER|AUTO*|ALWAYS]")
+set(SELF_BUILT_JSON "AUTO" CACHE STRING "rule to allow self build of Json dependency library [NEVER|AUTO*|ALWAYS]")
+# This is AUTO cause CED is not available on ubuntu
+set(SELF_BUILT_CED "AUTO" CACHE STRING "rule to allow self build of Ced dependency library [NEVER|AUTO*|ALWAYS]")
 
 set(Aubio_REQUIRED_VERSION "0.4.9")
 
@@ -332,10 +334,3 @@
 			)
 		message(STATUS "Resolving runtime dependencies for $<TARGET_FILE:performous>")
 		foreach(dep ${deps_resolved})
-			file(INSTALL ${dep} DESTINATION ${CMAKE_INSTALL_PREFIX})
-		endforeach()
-		foreach(dep ${deps_unresolved})
-			message(WARNING "Runtime dependency ${dep} could not be resolved.")
-		endforeach()
-		]])
-elseif(MINGW)

=== lang/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

# It should be possible to switch to CMake's GETTEXT_CREATE_TRANSLATIONS
# if we either drop the LOCALE_DIR or that function gets a customised
# INSTALL_DESTINATION.
# FIXME: Always execute msgmerge, like in CMake's GETTEXT_CREATE_TRANSLATIONS?

file(GLOB _languages *.po)
set(_mofiles)
foreach(_pofile ${_languages})
	get_filename_component(_language ${_pofile} NAME_WE)
	if(WIN32)
		# For some reason we need this structure on Windows to make localization work for a local build folder without install.
		set(_mofile ${CMAKE_CURRENT_BINARY_DIR}/${_language}/LC_MESSAGES/${CMAKE_PROJECT_NAME}.mo)
	else()
		set(_mofile ${CMAKE_CURRENT_BINARY_DIR}/${_language}.mo)
	endif()

	add_custom_command(
		OUTPUT ${_mofile}
		COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -v ${_pofile} -o ${_mofile}
		DEPENDS ${_pofile}
		COMMENT "Building ${_language} locale"
		VERBATIM)
	install(FILES ${_mofile} DESTINATION ${LOCALE_DIR}/${_language}/LC_MESSAGES RENAME ${CMAKE_PROJECT_NAME}.mo)
	set(_mofiles ${_mofiles} ${_mofile})
endforeach()

add_custom_target(translations ALL DEPENDS ${_mofiles})

=== osx-utils/CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,12 @@
 	PERFORMOUS_FONTS_CONF
 )
 
-string(REPLACE "<dir>@PERFORMOUS_SYSTEM_PREFIX@"
-	"<dir prefix='relative'>../../../Resources" PERFORMOUS_FONTS_CONF
+string(REPLACE "<dir>${PERFORMOUS_SYSTEM_PREFIX}/share/fonts"
+	"<dir prefix='relative'>../../../Resources/fonts" PERFORMOUS_FONTS_CONF
 	"${PERFORMOUS_FONTS_CONF}")
 
-string(REPLACE "<dir>@PERFORMOUS_SYSTEM_PREFIX@/var/cache"
-	"~/.cache" PERFORMOUS_FONTS_CONF
+string(REPLACE "<cachedir>${PERFORMOUS_SYSTEM_PREFIX}/var/cache"
+	"<cachedir>~/Library/Caches/Performous" PERFORMOUS_FONTS_CONF
 	"${PERFORMOUS_FONTS_CONF}")
 
 string(REPLACE "<!-- Font directory list -->"
@@ -37,12 +37,12 @@
 	<dir prefix='relative'>../../pixmaps</dir>]=] PERFORMOUS_FONTS_CONF
 	"${PERFORMOUS_FONTS_CONF}")
 
-string(REPLACE "@PERFORMOUS_SYSTEM_PREFIX@/share"
+string(REPLACE "${PERFORMOUS_SYSTEM_PREFIX}/share"
 	"../../../Resources" PERFORMOUS_FONTS_CONF
 	"${PERFORMOUS_FONTS_CONF}")
 
 file(WRITE
-	"${CMAKE_INSTALL_SYSCONFDIR}/fonts/fonts.conf"
+	"${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_SYSCONFDIR}/fonts/fonts.conf"
 	"${PERFORMOUS_FONTS_CONF}")
 
 install(DIRECTORY

=== docs/man/CMakeLists.txt ===
find_program(HELP2MAN help2man DOC "Location of the help2man program")
find_program(GZIP gzip DOC "Location of the gzip program")
mark_as_advanced(HELP2MAN)
mark_as_advanced(GZIP)
if(HELP2MAN AND GZIP)
	set(MANFILE ${CMAKE_CURRENT_BINARY_DIR}/performous.6.gz)
	set(H2MFILE ${CMAKE_CURRENT_SOURCE_DIR}/performous.h2m)
	add_custom_command(
		OUTPUT ${MANFILE}
		COMMAND ${HELP2MAN} "$<TARGET_FILE:performous>" -s 6 -i ${H2MFILE} -N | ${GZIP} > ${MANFILE}
		MAIN_DEPENDENCY ${H2MFILE}
		DEPENDS performous
		COMMENT "Building Performous man page"
		VERBATIM
	)
	add_custom_target(manpage ALL DEPENDS ${MANFILE})
	install(FILES ${MANFILE} TYPE MAN)
else(HELP2MAN AND GZIP)
	message("WARNING: One of the following is missing: help2man, gzip; performous man page will not be generated")
endif(HELP2MAN AND GZIP)
if(ENABLE_TOOLS AND GZIP)
	set(TOOLS 
		"ss_pak_extract" "ss_extract" "ss_cover_conv"
		"ss_adpcm_decode" "ss_ipu_conv" "ss_chc_decode"
		"gh_fsb_decrypt" "gh_xen_decrypt")
	set(MAN_SECTION "1")
	foreach(TOOL ${TOOLS})
		set(TOOL_MANFILE ${CMAKE_CURRENT_SOURCE_DIR}/${TOOL}.${MAN_SECTION})
		set(TOOL_MANFILE_GZ ${CMAKE_CURRENT_BINARY_DIR}/${TOOL}.${MAN_SECTION}.gz)
		add_custom_command(
			OUTPUT ${TOOL_MANFILE_GZ}
			COMMAND ${GZIP} -c ${TOOL_MANFILE} > ${TOOL_MANFILE_GZ}
			MAIN_DEPENDENCY ${TOOL_MANFILE}
			COMMENT "Building ${TOOL} man page"
			VERBATIM
		)
		add_custom_target(${TOOL}.${MAN_SECTION} ALL DEPENDS ${TOOL_MANFILE_GZ})
		install(FILES ${TOOL_MANFILE_GZ} DESTINATION share/man/man${MAN_SECTION})
	endforeach(TOOL)
endif(ENABLE_TOOLS AND GZIP)

=== debian/changelog ===
performous (1.3.1+ds-3ubuntu2) resolute; urgency=medium

  * No-change rebuild for ffmpeg 8.

 -- Rik Mills <rikmills@kde.org>  Wed, 31 Dec 2025 22:17:02 +0000

performous (1.3.1+ds-3ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/p/fix_ftbfs_boost.patch: Apply upstream patch to fix FTBS with boost.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 24 Dec 2025 09:18:15 +0100

performous (1.3.1+ds-3) unstable; urgency=medium

  * Team upload.

  [ lizhuoheng ]
  * Fix FTBFS with FFmpeg 8 (Closes: #1122941)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 20 Dec 2025 14:48:15 +0100

performous (1.3.1+ds-2ubuntu2) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Dec 2025 22:50:48 +0100

performous (1.3.1+ds-2ubuntu1) resolute; urgency=medium

  * d/p/fix_ftbfs_boost.patch: Apply upstream patch to fix FTBS with boost.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 04 Nov 2025 21:47:07 +0000

performous (1.3.1+ds-2build1) resolute; urgency=medium

  * No-change rebuild for libportmidi2.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 31 Oct 2025 22:01:51 +0000

performous (1.3.1+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1113397

 -- Andreas Tille <tille@debian.org>  Sun, 26 Oct 2025 15:59:52 +0100

performous (1.3.1+ds-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Team upload.
  * Improve cross building: Don't run unit tests when DEB_BUILD_OPTIONS
    contains nocheck. (Closes: #1095962)

  [ Andreas Tille ]
  * Fix watch file
  * Import ced into multi tarball source
  * Standards-Version: 4.7.2
  * Remove obsolete field Name from debian/upstream/metadata
  * Rely on pre-initialized dpkg-architecture variables.

 -- Andreas Tille <tille@debian.org>  Thu, 11 Sep 2025 21:12:19 +0200

=== debian/control ===
Source: performous
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Miriam Ruiz <miriam@debian.org>,
 Markus Koschany <apo@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 gettext,
 help2man,
 libaubio-dev,
 libavcodec-dev,
 libavformat-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-locale-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libcpprest-dev,
 libepoxy-dev,
 libfftw3-dev,
 libfmt-dev,
 libfreetype-dev,
 libglm-dev,
 libgmock-dev,
 libgtest-dev,
 libicu-dev,
 libjpeg-dev,
 libopencv-dev,
 libpango1.0-dev,
 libportmidi-dev [linux-any],
 librsvg2-dev,
 libsdl2-dev,
 libssl-dev,
 libswscale-dev,
 libxml++2.6-dev,
 nlohmann-json3-dev,
 portaudio19-dev,
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/games-team/performous.git
Vcs-Browser: https://salsa.debian.org/games-team/performous
Homepage: https://performous.org/

Package: performous
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fretsonfire-songs-muldjord,
 fretsonfire-songs-sectoid,
Description: karaoke game that allows user supplied songs
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 LC_ALL:=C.UTF-8
 export LC_ALL
 
-DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
+include /usr/share/dpkg/architecture.mk
 
 OUR_CPPFLAGS:=
 OUR_CXXFLAGS:=
@@ -33,17 +33,17 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DCMAKE_VERBOSE_MAKEFILE=ON \
-		-DCMAKE_INSTALL_PREFIX=/usr
+		-DCMAKE_INSTALL_PREFIX=/usr \
+		-DBUILD_TESTS=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON) \
+		-DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
-override_dh_install:
-	dh_install
+execute_after_dh_install:
 	mkdir -p debian/performous/usr/games
 	mv debian/performous/usr/bin/performous debian/performous/usr/games/
 	rmdir --ignore-fail-on-non-empty debian/performous/usr/bin
 	mkdir -p debian/performous/usr/share/icons/hicolor/scalable/apps
-	mv debian/performous/usr/share/pixmaps/performous.svg \
-		debian/performous/usr/share/icons/hicolor/scalable/apps/
-	rmdir --ignore-fail-on-non-empty debian/performous/usr/share/pixmaps
+	cp -a debian/performous/usr/share/games/performous/themes/default/icon.svg \
+		debian/performous/usr/share/icons/hicolor/scalable/apps/performous.svg
 	mkdir -p debian/performous/usr/share/man/man6
 	mv debian/performous/usr/share/man/performous.6.gz \
 		debian/performous/usr/share/man/man6/performous.6.gz
